// ChildView.cpp : implementation of the CChildView class
//

#include "stdafx.h"
#include "MFCRoot.h"
#include "ChildView.h"

#include <Windows4Root.h>
#include <TCanvas.h>
#include <TF1.h>
#include <TF2.h>
#include <TF3.h>
#include <TH1.h>
#include <TH2.h>
#include <TStyle.h>
#ifdef GetFreeSpace
#undef GetFreeSpace
#endif
#include <TGeoManager.h>
#include ".\childview.h"

#ifdef _DEBUG
//#define new DEBUG_NEW
#endif

// CChildView

CChildView::CChildView()
{
   fCanvas = 0;
}

CChildView::~CChildView()
{
   delete fCanvas;
   fCanvas = 0;
}


BEGIN_MESSAGE_MAP(CChildView, CWnd)
	ON_WM_PAINT()
   ON_WM_LBUTTONDBLCLK()
   ON_WM_LBUTTONDOWN()
   ON_WM_LBUTTONUP()
   ON_WM_MBUTTONDBLCLK()
   ON_WM_MBUTTONDOWN()
   ON_WM_MBUTTONUP()
   ON_WM_MDIACTIVATE()
   ON_WM_RBUTTONDBLCLK()
   ON_WM_RBUTTONDOWN()
   ON_WM_RBUTTONUP()
   ON_WM_SIZE()
   ON_WM_MOUSEMOVE()
   ON_WM_SETCURSOR()
   ON_COMMAND(ID_2DHISTOS, On2dhistos)
   ON_COMMAND(ID_2DFUNC, On2dfunc)
   ON_COMMAND(ID_SURFACES, OnSurfaces)
   ON_COMMAND(ID_OPTIONS_GLINPAD, OnOptionsGlinpad)
END_MESSAGE_MAP()



// CChildView message handlers

BOOL CChildView::PreCreateWindow(CREATESTRUCT& cs) 
{
	if (!CWnd::PreCreateWindow(cs))
		return FALSE;

	cs.dwExStyle |= WS_EX_CLIENTEDGE;
	cs.style &= ~WS_BORDER;
	cs.lpszClass = AfxRegisterWndClass(CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS, 
		::LoadCursor(NULL, IDC_ARROW), reinterpret_cast<HBRUSH>(COLOR_WINDOW+1), 
      ::LoadIcon(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDI_ICON1)));

	return TRUE;
}

void CChildView::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	// TODO: Add your message handler code here
   RECT rect;
   if (fCanvas == 0) {
      GetWindowRect(&rect);
      int width  = rect.right-rect.left;
      int height = rect.bottom-rect.top;
      int wid = gVirtualX->AddWindow((ULong_t)m_hWnd, width, height);

      fCanvas = new TCanvas("fCanvas", width, height, wid);
      fCanvas->SetFillColor(10);
      fCanvas->SetBorderMode(0);
   }
   if (fCanvas)
      fCanvas->Update();
	
	// Do not call CWnd::OnPaint() for painting messages
}


void CChildView::OnLButtonDblClk(UINT nFlags, CPoint point)
{
   // TODO: Add your message handler code here and/or call default

   CWnd::OnLButtonDblClk(nFlags, point);
}

void CChildView::OnLButtonDown(UINT nFlags, CPoint point)
{
   // TODO: Add your message handler code here and/or call default
   if (fCanvas)
      fCanvas->HandleInput(kButton1Down, point.x, point.y);

   CWnd::OnLButtonDown(nFlags, point);
}

void CChildView::OnLButtonUp(UINT nFlags, CPoint point)
{
   // TODO: Add your message handler code here and/or call default
   if (fCanvas)
      fCanvas->HandleInput(kButton1Up, point.x, point.y);

   CWnd::OnLButtonUp(nFlags, point);
}

void CChildView::OnMButtonDblClk(UINT nFlags, CPoint point)
{
   // TODO: Add your message handler code here and/or call default

   CWnd::OnMButtonDblClk(nFlags, point);
}

void CChildView::OnMButtonDown(UINT nFlags, CPoint point)
{
   // TODO: Add your message handler code here and/or call default
   if (fCanvas)
      fCanvas->HandleInput(kButton2Down, point.x, point.y);

   CWnd::OnMButtonDown(nFlags, point);
}

void CChildView::OnMButtonUp(UINT nFlags, CPoint point)
{
   // TODO: Add your message handler code here and/or call default
   if (fCanvas)
      fCanvas->HandleInput(kButton2Up, point.x, point.y);

   CWnd::OnMButtonUp(nFlags, point);
}

void CChildView::OnMDIActivate(BOOL bActivate, CWnd* pActivateWnd, CWnd* pDeactivateWnd)
{
   CWnd::OnMDIActivate(bActivate, pActivateWnd, pDeactivateWnd);

   // TODO: Add your message handler code here
}

void CChildView::OnRButtonDblClk(UINT nFlags, CPoint point)
{
   // TODO: Add your message handler code here and/or call default

   CWnd::OnRButtonDblClk(nFlags, point);
}

void CChildView::OnRButtonDown(UINT nFlags, CPoint point)
{
   // TODO: Add your message handler code here and/or call default
   CWnd::OnRButtonDown(nFlags, point);
   if (fCanvas)
      fCanvas->HandleInput(kButton3Down, point.x, point.y);

}

void CChildView::OnRButtonUp(UINT nFlags, CPoint point)
{
   // TODO: Add your message handler code here and/or call default
   CWnd::OnRButtonUp(nFlags, point);
   if (fCanvas)
      fCanvas->HandleInput(kButton3Up, point.x, point.y);

}

void CChildView::OnSize(UINT nType, int cx, int cy)
{
   CWnd::OnSize(nType, cx, cy);

   // TODO: Add your message handler code here
   if (fCanvas)
      fCanvas->Resize();
}

void CChildView::OnMouseMove(UINT nFlags, CPoint point)
{
   // TODO: Add your message handler code here and/or call default
   static CPoint lastPoint;
   if (fCanvas) {
      if (nFlags & MK_LBUTTON) {
         fCanvas->HandleInput(kButton1Motion, point.x, point.y);
      } else if (nFlags == 0) {
         if (point != lastPoint) {
            fCanvas->HandleInput(kMouseMotion, point.x, point.y);
            lastPoint = point;
         }
      }
   }
   CWnd::OnMouseMove(nFlags, point);
}

BOOL CChildView::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message)
{
   // TODO: Add your message handler code here and/or call default
   if (fCanvas)
      return FALSE;
   return CWnd::OnSetCursor(pWnd, nHitTest, message);
}

void CChildView::On2dhistos()
{
   // TODO: Add your command handler code here
   if (fCanvas) {
      gStyle->SetOptStat(0);
      gStyle->SetPalette(1);
      gStyle->SetCanvasColor(33);
      gStyle->SetFrameFillColor(18);
      f1 = new TF2("f1","xygaus + xygaus(5) + xylandau(10)",-4,4,-4,4);
      Double_t params[] = {130,-1.4,1.8,1.5,1, 150,2,0.5,-2,0.5, 3600,-2,0.7,-3,0.3};
      f1->SetParameters(params);
      h2 = new TH2F("h2","xygaus + xygaus(5) + xylandau(10)",20,-4,4,20,-4,4);
      h2->SetFillColor(46);
      h2->FillRandom("f1",40000);
      Float_t x1=0.67, y1=0.875, x2=0.85, y2=0.95;
      fCanvas->Clear();
      fCanvas->Divide(2,2);
      fCanvas_1 = fCanvas->cd(1);
      fCanvas_1->SetFillColor(17);
      if (gStyle->GetCanvasPreferGL())
         h2->Draw("glsurf1");
      else
         h2->Draw("surf1");
      fCanvas_2 = fCanvas->cd(2);
      fCanvas_2->SetFillColor(17);
      if (gStyle->GetCanvasPreferGL())
         h2->Draw("glsurf2z");
      else
         h2->Draw("surf2z");
      fCanvas_3 = fCanvas->cd(3);
      fCanvas_3->SetFillColor(17);
      if (gStyle->GetCanvasPreferGL())
         h2->Draw("glsurf3");
      else
         h2->Draw("surf3");
      fCanvas_4 = fCanvas->cd(4);
      fCanvas_4->SetFillColor(17);
      if (gStyle->GetCanvasPreferGL())
         h2->Draw("glsurf4");
      else
         h2->Draw("surf4");
      fCanvas->Update();
   }
}

void CChildView::On2dfunc()
{
   // TODO: Add your command handler code here
   if (fCanvas) {
      gStyle->SetFrameFillColor(42);

      fCanvas->Clear();
      fCanvas->Divide(2, 2);

      fCanvas_1 = fCanvas->cd(1);
      fCanvas_1->SetFillColor(17);
      fun1 = new TF2("fun1","x * x - y * y - 1", -6., 6., -6., 6.);
      fun1->SetFillColor(kRed);
      if (gStyle->GetCanvasPreferGL())
         fun1->Draw("glsurf2");
      else
         fun1->Draw("surf2");

      fCanvas_2 = fCanvas->cd(2);
      fCanvas_2->SetFillColor(17);
      fun2 = new TF2("fun2","x * x + y * y - 1", -6., 6., -6., 6.);
      fun2->SetFillColor(kGreen);
      if (gStyle->GetCanvasPreferGL())
         fun2->Draw("glsurf1");
      else
         fun2->Draw("surf1");

      fCanvas_3 = fCanvas->cd(3);
      fCanvas_3->SetFillColor(17);
      fun3 = new TF2("fun3","sin(x) / x * cos(y) * y", -6., 6., -6., 6.);
      fun3->SetFillColor(kWhite);
      if (gStyle->GetCanvasPreferGL())
         fun3->Draw("glsurf");
      else
         fun3->Draw("surf");

      fCanvas_4 = fCanvas->cd(4);
      fCanvas_4->SetFillColor(17);
      fun4 = new TF3("TF3 sample","sin(x * x + y * y + z * z - 4)", -2.5, 2.5, -2.5, 2.5, -2.5, 2.5);
      fun4->SetFillColor(kMagenta);
      if (gStyle->GetCanvasPreferGL())
         fun4->Draw("gl");
      else
         fun4->Draw();
      fCanvas->Update();
   }
}

void CChildView::OnSurfaces()
{
   // TODO: Add your command handler code here
   if (fCanvas) {
      gStyle->SetFrameFillColor(42);

      fCanvas->Clear();
      fCanvas->cd();

      pad1 = new TPad("pad1","Gouraud shading", 0.51, 0.02, 0.98, 0.98, 21);
      pad2 = new TPad("pad2","Color mesh", 0.02, 0.02, 0.48, 0.98, 21);
      pad1->SetFillColor(17);
      pad2->SetFillColor(17);
      pad1->Draw();
      pad2->Draw();
      // We generate a 2-D function
      f2 = new TF2("f2","x**2 + y**2 - x**3 -8*x*y**4", -1., 1.2, -1.5, 1.5);
      // Draw this function in pad1 with Gouraud shading option
      pad1->cd();
      pad1->SetLogz();
      f2->SetFillColor(45);
      if (gStyle->GetCanvasPreferGL())
         f2->Draw("glsurf4");
      else
         f2->Draw("surf4");

      f2clone = new TF2("f2","x**2 + y**2 - x**3 -8*x*y**4", -1., 1.2, -1.5, 1.5);
      // Draw this function in pad2 with color mesh option
      pad2->cd();
      pad2->SetLogz();
      if (gStyle->GetCanvasPreferGL())
         f2clone->Draw("glsurf1");
      else
         f2clone->Draw("surf1");
   
      //add axis titles. The titles are set on the intermediate
      //histogram used for visualisation. We must force this histogram
      //to be created, then force the redrawing of the two pads

      pad2->Update();
      f2->GetHistogram()->GetXaxis()->SetTitle("x title");
      f2->GetHistogram()->GetYaxis()->SetTitle("y title");
      f2->GetHistogram()->GetXaxis()->SetTitleOffset(1.4);
      f2->GetHistogram()->GetYaxis()->SetTitleOffset(1.4);
      f2clone->GetHistogram()->GetXaxis()->SetTitle("x title");
      f2clone->GetHistogram()->GetYaxis()->SetTitle("y title");
      f2clone->GetHistogram()->GetXaxis()->SetTitleOffset(1.4);
      f2clone->GetHistogram()->GetYaxis()->SetTitleOffset(1.4);

      pad1->Modified();
      pad2->Modified();
      pad1->Update();
      pad2->Update();
      fCanvas->Update();
   }
}

void CChildView::OnOptionsGlinpad()
{
   // TODO: Add your command handler code here
   CWnd* pMain = AfxGetMainWnd();
   CMenu* pMenu = pMain->GetMenu();
   UINT state = pMenu->GetMenuState(ID_OPTIONS_GLINPAD, MF_BYCOMMAND);
   if (state & MF_CHECKED) {
      pMenu->CheckMenuItem(ID_OPTIONS_GLINPAD, MF_UNCHECKED);
      gStyle->SetCanvasPreferGL(false);
   }
   else {
      pMenu->CheckMenuItem(ID_OPTIONS_GLINPAD, MF_CHECKED);
      gStyle->SetCanvasPreferGL(true);
   }
   pMain->DrawMenuBar();
}

