// MFCRoot.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "MFCRoot.h"
#include "MainFrm.h"

#include "ChildFrm.h"

#include <Windows4Root.h>
#include <TROOT.h>
#include <TWin32SplashThread.h>
#include <TApplication.h>
#include <TSystem.h>
#include <TPluginManager.h>
#include <TVirtualGL.h>
#include <TBrowser.h>
#include <TVirtualX.h>
#include <TStyle.h>

#ifdef _DEBUG
//#define new DEBUG_NEW
#endif

// CMFCRootApp

BEGIN_MESSAGE_MAP(CMFCRootApp, CWinApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	ON_COMMAND(ID_FILE_NEW, OnFileNew)
   ON_COMMAND(ID_OPTIONS_GLINPAD, OnOptionsGlinpad)
END_MESSAGE_MAP()

TApplication *gMFCRootApp;

// CMFCRootApp construction

CMFCRootApp::CMFCRootApp()
{
	EnableHtmlHelp();

	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
   int argc = 1;
   char *argv[] = {
      "MFCRootApp.exe",
      NULL
   };
   gMFCRootApp = new TApplication("MFC ROOT Application", &argc, argv);
   gMFCRootApp->SetReturnFromRun(true);
}


// The one and only CMFCRootApp object

CMFCRootApp theApp;

// CMFCRootApp initialization

BOOL CMFCRootApp::InitInstance()
{
	// InitCommonControls() is required on Windows XP if an application
	// manifest specifies use of ComCtl32.dll version 6 or later to enable
	// visual styles.  Otherwise, any window creation will fail.
	InitCommonControls();

	CWinApp::InitInstance();

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	// of your final executable, you should remove from the following
	// the specific initialization routines you do not need
	// Change the registry key under which our settings are stored
	// TODO: You should modify this string to be something appropriate
	// such as the name of your company or organization
	SetRegistryKey(_T("Local AppWizard-Generated Applications"));
	// To create the main window, this code creates a new frame window
	// object and then sets it as the application's main window object
	CMDIFrameWnd* pFrame = new CMainFrame;
	if (!pFrame)
		return FALSE;
	m_pMainWnd = pFrame;
	// create main MDI frame window
	if (!pFrame->LoadFrame(IDR_MAINFRAME))
		return FALSE;
	// try to load shared MDI menus and accelerator table
	//TODO: add additional member variables and load calls for
	//	additional menu types your application may need
	HINSTANCE hInst = AfxGetResourceHandle();
	m_hMDIMenu  = ::LoadMenu(hInst, MAKEINTRESOURCE(IDR_MFCRootTYPE));
	m_hMDIAccel = ::LoadAccelerators(hInst, MAKEINTRESOURCE(IDR_MFCRootTYPE));
	// The main window has been initialized, so show and update it
	pFrame->ShowWindow(m_nCmdShow);
	pFrame->UpdateWindow();
   new TWin32SplashThread(kFALSE);
/*
   gSystem->Load("libGraf3d");
   if (!gROOT->GetListOfSpecials()->FindObject("R__TVirtualUtil3D")) {
      TPluginHandler *h = gROOT->GetPluginManager()->FindHandler("TVirtualUtil3D");
      if (h && h->LoadPlugin() != -1)
         h->ExecPlugin(0);
   }
*/
   if (!gGLManager) {
      TPluginHandler *ph = gROOT->GetPluginManager()->FindHandler("TGLManager", "win32");
      if (ph && ph->LoadPlugin() != -1)
         ph->ExecPlugin(0);
   }
   gStyle->SetCanvasPreferGL(false);

	return TRUE;
}


// CMFCRootApp message handlers

int CMFCRootApp::ExitInstance() 
{
	//TODO: handle additional resources you may have added
	if (m_hMDIMenu != NULL)
		FreeResource(m_hMDIMenu);
	if (m_hMDIAccel != NULL)
		FreeResource(m_hMDIAccel);

   TWin32SplashThread *delSplash = gSplash;
   if (gSplash) {
      gSplash = 0;
      delete delSplash;
   }
   gApplication->Terminate();

	return CWinApp::ExitInstance();
}

void CMFCRootApp::OnFileNew() 
{
	CMainFrame* pFrame = STATIC_DOWNCAST(CMainFrame, m_pMainWnd);
	// create a new MDI child window
	pFrame->CreateNewChild(
		RUNTIME_CLASS(CChildFrame), IDR_MFCRootTYPE, m_hMDIMenu, m_hMDIAccel);
}


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()

// App command to run the dialog
void CMFCRootApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}


// CMFCRootApp message handlers


void CMFCRootApp::OnOptionsGlinpad()
{
   // TODO: Add your command handler code here
   CWnd* pMain = AfxGetMainWnd();
   CMenu* pMenu = pMain->GetMenu();
   UINT state = pMenu->GetMenuState(ID_OPTIONS_GLINPAD, MF_BYCOMMAND);
   if (state & MF_CHECKED) {
      pMenu->CheckMenuItem(ID_OPTIONS_GLINPAD, MF_UNCHECKED);
      gStyle->SetCanvasPreferGL(false);
   }
   else {
      pMenu->CheckMenuItem(ID_OPTIONS_GLINPAD, MF_CHECKED);
      gStyle->SetCanvasPreferGL(true);
   }
   pMain->DrawMenuBar();
}
